/***************************************************************/
/* Prof. Dr. Carsten Vogt                                      */
/* FH Koeln, Fak. 07 / Nachrichtentechnik                      */
/* http://www.nt.fh-koeln.de/vogt                              */
/*                                                             */
/* Beispielprogramm Nr. 15                                     */
/* der frueheren Vorlesung Datenverarbeitung                   */
/*                                                             */
/* Das Programm zeigt geschachtelte Bloecke in C mit der       */
/* Verdeckung einer inneren Variablen.                         */
/***************************************************************/

#include <stdio.h>
#include <conio.h>

main() {

  float giro, sparbuch, vermoegen;

  /* Einlesen zweier Kontostaende. */
  printf("Bitte Staende des Girokontos und Sparbuchs eingeben: ");
  scanf("%f %f",&giro,&sparbuch);

  /* Berechnung des Gesamtvermoegens. */
  vermoegen = giro + sparbuch;

  printf("Einstieg in inneren Block\n");

  {
    /* Deklaration zweier neuer Variablen in einem inneren Block.
       Neue Variable 'vermoegen' verdeckt die gleichnamige Variable
       des aeusseren Blocks. */
    float sparbuch_m_zins, vermoegen;

    sparbuch_m_zins = 1.02*sparbuch;

    /* Zuweisung an 'vermoegen' im inneren Block */
    vermoegen = giro + sparbuch_m_zins;
    printf("Vermoegen mit Zinsen: %4.2f\n",vermoegen);

  } /* innerer Block zuende -> seine Variablen werden geloescht. */

  printf("Rueckkehr aus innerem Block\n");

  /* Ausgabe der auesseren Variablen 'vermoegen'. */
  printf("Vermoegen ohne Zinsen: %4.2f\n",vermoegen);

 getch();

}
