/***************************************************************/
/* Prof. Dr. Carsten Vogt                                      */
/* FH Koeln, Fak. 07 / Nachrichtentechnik                      */
/* http://www.nt.fh-koeln.de/vogt                              */
/*                                                             */
/* Beispielprogramm Nr. 25                                     */
/* der frueheren Vorlesung Datenverarbeitung                   */
/*                                                             */
/* Das Programm zeigt die Wertzuweisung zwischen zwei Arrays   */
/***************************************************************/

#include <stdio.h>
#include <conio.h>

main() {

 /* Deklaration zweier Arrays a und b sowie Vorbesetzung von b */

 int a[3], b[3] = {1,2,3};

 /* Laufvariable */

 int i;

 /* Versuch der Uebertragung aller Werte von b nach a durch
    Anweisung "a = b;":
    falsch, da a intern als Zeigerkonstante behandelt wird und
    somit keine Wertzuweisungen erlaubt sind. Die entsprechende
    Compilermeldung "lvalue required" besagt, dass links der Zu-
    weisung die Adresse eines beschreibbaren Speicherbereichs
    erwartet wird, was a aber nicht ist. */

 a = b;

 /* korrekte Uebertragung aller Werte von b nach a:
    Verwendung einer for-Schleife, in der die Werte einzeln ueber-
    tragen werden */

 for (i=0;i<3;i++)
  a[i]=b[i];

 getch();

}
