/***************************************************************/
/* Prof. Dr. Carsten Vogt                                      */
/* FH Koeln, Fak. 07 / Nachrichtentechnik                      */
/* http://www.nt.fh-koeln.de/vogt                              */
/*                                                             */
/* Beispielprogramm Nr. 24                                     */
/* der frueheren Vorlesung Datenverarbeitung                   */
/*                                                             */
/* Das Programm zeigt einfache Operationen auf einem Array:    */
/* 1.) Besetzen aller Array-Komponenten mit 0                  */
/* 2.) Einlesen aller Array-Komponenten von der Tastatur       */
/* 3.) Vorbesetzen der ersten Array-Komponente und Berechnung  */
/*     aller anderen aus dem Wert ihres jeweiligen Vorgaengers */
/***************************************************************/

#include <stdio.h>
#include <conio.h>

main() {

 /* Deklaration eines Arrays mit 12 float-Eintraegen:
    Monatsumsaetze einer Firma */

 float umsaetze[12];

 /* Deklaration einer Laufvariablen */

 int   i;

 /* Besetzen aller Arraykomponenten mit 0 */

 for (i=0;i<=11;i++)
  umsaetze[i] = 0;

 /* Einlesen aller Arraykomponenten von der Tastatur */

 for (i=0;i<=11;i++)
  scanf("%f",&umsaetze[i]);

 /* Januar-Umsatz auf 1000.00 setzen */

 umsaetze[0] = 1000.00;

 for (i=1;i<=11;i++)
  /* in jedem Monat zwei Prozent mehr Umsatz als im Vormonat */
  umsaetze[i] = 1.02 * umsaetze[i-1];

 getch();

}
