/***************************************************************/
/* Prof. Dr. Carsten Vogt                                      */
/* FH Koeln, Fak. 07 / Nachrichtentechnik                      */
/* http://www.nt.fh-koeln.de/vogt                              */
/*                                                             */
/* Beispielprogramm Nr. 47                                     */
/* der frueheren Vorlesung Datenverarbeitung                   */
/*                                                             */
/* Das Programm demonstriert die Benutzung                     */
/* von statischen Variablen.                                   */
/***************************************************************/

#include <stdio.h>
#include <conio.h>

int zaehler() {

 /* Die Funktion zaehlt bei jedem Aufruf die statische Variable count
    um 1 hoch und gibt den aktuellen Wert von count zurueck.
    Eine statische Variable ist lokal in einer Funktion vereinbart.
    Sie wird jedoch nicht beim Verlassen der Funktion geloescht,
    sondern bleibt bestehen, so dass beim naechsten Funktionsaufruf
    ihr Wert noch zur Verfuegung steht.
    Statische Variablen werden automatisch mit 0 initialisiert. */

 static int count;

 count++;
 return count;

}

main() {

 /* Das Hauptrogramm ruft die Funktion dreimal auf und gibt dann
    jeweils den aktuellen Wert der statischen Varaiablen aus. */

 printf("%d\n",zaehler());  /* Ausgabe: 1 */
 printf("%d\n",zaehler());  /* Ausgabe: 2 */
 printf("%d\n",zaehler());  /* Ausgabe: 3 */

 getch();

}
