/***************************************************************/
/* Prof. Dr. Carsten Vogt                                      */
/* FH Koeln, Fak. 07 / Nachrichtentechnik                      */
/* http://www.nt.fh-koeln.de/vogt                              */
/*                                                             */
/* Beispielprogramm Nr. 48                                     */
/* der frueheren Vorlesung Datenverarbeitung                   */
/*                                                             */
/* Das Programm demonstriert die Benutzung                     */
/* von globalen Variablen.                                     */
/***************************************************************/

#include <stdio.h>
#include <conio.h>

/* Die Variable zaehler wird ausserhalb der Funktionen deklariert.
   Sie ist damit eine globale Variable, die von allen Funktionen
   benutzt werden kann.
   Globale Variablen werden automatisch mit 0 initialisiert. */

int zaehler; /* zaehlt die Gesamtzahl aller Funktionsaufrufe.
                In jeder Funktion wird zaehler um 1 erhoeht. */

void fct_1()
 { zaehler++; }

void fct_2()
 { zaehler++; }

main() {

 zaehler++; /* zaehlt den Aufruf des Hauptprogramms main() */

 fct_1();

 fct_2();

 printf("Anzahl durchlaufener Funktionen: %d\n",zaehler);

 getch();

}

